from Wizard import wizardManager
from Screens.WizardLanguage import WizardLanguage
from Screens.ScanSetup import DefaultSatLists
from Screens.DefaultWizard import DefaultWizard
from Screens.Rc import Rc

from Components.Pixmap import Pixmap
from Components.config import config, ConfigBoolean, configfile, ConfigSubsection

from LanguageSelection import LanguageWizard
from Components.NimManager import nimmanager

config.misc.firstrun = ConfigBoolean(default = True)
config.misc.startwizard = ConfigSubsection()
config.misc.startwizard.shownimconfig = ConfigBoolean(default = True)
config.misc.startwizard.doservicescan = ConfigBoolean(default = True)
config.misc.languageselected = ConfigBoolean(default = True)

class StartWizard(DefaultSatLists, Rc):
	def __init__(self, session, silent = True, showSteps = False, neededTag = None):
		self.xmlfile = ["startwizard.xml", "defaultsatlists.xml"]
		WizardLanguage.__init__(self, session, showSteps = False)
		DefaultWizard.__init__(self, session, silent, showSteps, neededTag = "services")
		Rc.__init__(self)
		self["wizard"] = Pixmap()
				
	def markDone(self):
		config.misc.firstrun.value = 0
		config.misc.firstrun.save()
		configfile.save()

	def setTunerText(self, step):
		index = {"nima": 0, "nimb": 1, "nimc": 2, "nimd": 3}.get(step, None)
		text = ""
		if index == 0:
			text += _("Use the left and right buttons to change an option.") + "\n\n"
		text += _("Please set up tuner %s") % nimmanager.getNimSlotName(index)
		
		return text
		
wizardManager.registerWizard(LanguageWizard, config.misc.languageselected.value, priority = 5)
wizardManager.registerWizard(StartWizard, config.misc.firstrun.value, priority = 20)
